<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/**
 * Game AdminPanel (АдминПанель)
 *
 * 
 *
 * @package		Game AdminPanel
 * @author		Nikita Kuznetsov (ET-NiK)
 * @copyright	Copyright (c) 2013, Nikita Kuznetsov (http://hldm.org)
 * @license		http://gameap.ru/license.html
 * @link		http://gameap.ru
 * @filesource	
 */
 
// ------------------------------------------------------------------------

/**
 * Хук заменяет языковые конструкции {lang_blablabla} на значения из 
 * языковых файлов.
 * Языковые файлы должны быть загружены в контролерах, которые
 * обрабатывают шаблоны.
 *
 * @package		Game AdminPanel
 * @category	Controllers
 * @category	Controllers
 * @author		Nikita Kuznetsov (ET-NiK)
 * @sinse		0.7
 */
class Lang_replace
{
	/**
	* Holds CI instance
	*
	* @var CI instance
	*/
	private $CI;
	
	public function __construct()
	{
		$this->CI =& get_instance();
	}
	
	function _get_lang_line($matches)
	{
		return $this->CI->lang->line($matches[1]);
	}
	
	public function parse_lang()
	{
		$output = $this->CI->output->get_output();
		
		/* Получаем обрамляющие знаки. Обычно это { и } */
		$l_delim = $this->CI->parser->l_delim;
		$r_delim = $this->CI->parser->r_delim;
		
		$output = preg_replace_callback('/' . $l_delim . 'lang\_([a-z\_\-]*)' . $r_delim . '/', array($this,'_get_lang_line'), $output);
		$this->CI->output->set_output($output);
	}
}
